;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_ty_intf
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_ty_decl #"ty_decl.scm")
    (__caml_modules #"modules.scm")
    (__caml_globals #"globals.scm")
    (__caml_types #"types.scm")
    (__caml_ty_error #"ty_error.scm")
    (__caml_misc #"misc.scm")
    (__caml_const #"const.scm"))
  (export
    (enter_interface_definitions_230@ty_intf x1)
    (check_interface_106@ty_intf x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define enter_interface_definitions_230@ty_intf
  (lambda (x1)
    (begin
      (cell-set! external_types_124@ty_decl '())
      (begin
        ((do_table_147@hashtbl
           (lambda (x2)
             (lambda (x3)
               (let ((x4 (let ((x4 (caml-constr-get-field
                                     (caml-constr-get-field x3 1)
                                     2)))
                           (labels
                             ((staticfail1000
                                ()
                                (begin (add_type_46@modules x3) #t)))
                             (let ((:-d.1001 x4))
                               (cond ((eq? :-d.1001 (caml-make-tag 0 4)) #f)
                                     (else (staticfail1000))))))))
                 (cell-set!
                   external_types_124@ty_decl
                   (cons (caml-make-regular
                           (caml-make-tag 0 1)
                           2
                           (caml-constr-get-field
                             (caml-constr-get-field x3 0)
                             1)
                           (caml-make-regular
                             (caml-make-tag 0 0)
                             3
                             x3
                             x4
                             #f))
                         (cell-ref external_types_124@ty_decl)))))))
         (types_of_module_132@modules x1))
        (begin
          ((do_table_147@hashtbl
             (lambda (x2)
               (lambda (x3)
                 (let ((x4 (caml-constr-get-field
                             (caml-constr-get-field x3 1)
                             1)))
                   (labels
                     ((staticfail1002 () (caml-make-tag 0 1)))
                     (case (if (caml-constant-constr? x4)
                             -1
                             (caml-regular-constr-tag x4))
                       ((2) (add_value_24@modules x3))
                       (else (staticfail1002))))))))
           (values_of_module_199@modules x1))
          (begin
            ((do_table_147@hashtbl
               (lambda (x2)
                 (lambda (x3) (add_constr_192@modules x3))))
             (constrs_of_module_249@modules x1))
            ((do_table_147@hashtbl
               (lambda (x2)
                 (lambda (x3) (add_label_68@modules x3))))
             (labels_of_module_207@modules x1))))))))

(define check_interface_106@ty_intf
  (lambda (x1)
    (let ((x2 (cell-ref defined_module_128@modules)))
      (let ((x3 (lambda (x3)
                  (let* ((handler-top1004 current_handler)
                         (:-d.1005 (unspecified)))
                    (labels
                      ((try1011
                         (:-d.1005)
                         (begin
                           (get-the-continuation :-d.1005)
                           (if (eq? #t #f) (try1011 (try1011 (try1011 1))))
                           (if :-d.1005
                             (let ((x4 ((find_75@hashtbl
                                          (values_of_module_199@modules x2))
                                        (little_name_of_global_209@globals
                                          x3))))
                               (let* ((handler-top1007 current_handler)
                                      (:-d.1008 (unspecified)))
                                 (labels
                                   ((try1009
                                      (:-d.1008)
                                      (begin
                                        (get-the-continuation :-d.1008)
                                        (if (eq? #t #f)
                                          (try1009 (try1009 (try1009 1))))
                                        (if :-d.1008
                                          (filter_45@types
                                            (caml-make-regular
                                              (caml-make-tag 0 1)
                                              2
                                              (type_instance_208@types
                                                (caml-constr-get-field
                                                  (caml-constr-get-field x4 1)
                                                  0))
                                              (caml-constr-get-field
                                                (caml-constr-get-field x3 1)
                                                0)))
                                          current_handler))))
                                   (let ((x5 (try1009 :-d.1008)))
                                     (set! current_handler handler-top1007)
                                     (if (=fx *try* 1)
                                       (begin
                                         (set! *try* 0)
                                         (labels
                                           ((staticfail1010 () (raise x5)))
                                           (case (caml-extensible-constr-tag x5)
                                             ((unify_1@types)
                                              ((type_mismatch_err_114@ty_error
                                                 x3)
                                               x4))
                                             (else (staticfail1010)))))
                                       x5)))))
                             current_handler))))
                      (let ((x4 (try1011 :-d.1005)))
                        (set! current_handler handler-top1004)
                        (if (=fx *try* 1)
                          (begin
                            (set! *try* 0)
                            (labels
                              ((staticfail1012 () (raise x4)))
                              (case (caml-extensible-constr-tag x4)
                                ((not_found_4@exc)
                                 (undefined_value_err_83@ty_error x3))
                                (else (staticfail1012)))))
                          x4)))))))
        ((do_table_147@hashtbl
           (lambda (x4)
             (lambda (x5)
               (let ((x6 (caml-constr-get-field
                           (caml-constr-get-field x5 1)
                           1)))
                 (labels
                   ((staticfail1013 () (caml-make-tag 0 1)))
                   (let ((:-d.1014 x6))
                     (cond ((eq? :-d.1014 (caml-make-tag 0 2)) (x3 x5))
                           (else (staticfail1013)))))))))
         (values_of_module_199@modules x1))))))

