;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_genlex
  (foreign (include #"caml-bigloo.h"))
  (import)
  (export
    initial_buffer_128@genlex
    buffer_20@genlex
    bufpos_62@genlex
    (reset_buffer_23@genlex x1)
    (store_147@genlex x1)
    (get_string_221@genlex x1)
    (make_lexer_140@genlex x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define initial_buffer_128@genlex
  (create_string 32))

(define buffer_20@genlex
  (make-cell initial_buffer_128@genlex))

(define bufpos_62@genlex (make-cell 0))
(define reset_buffer_23@genlex
  (lambda (x1)
    (begin
      (cell-set!
        buffer_20@genlex
        initial_buffer_128@genlex)
      (cell-set! bufpos_62@genlex 0))))

(define store_147@genlex
  (lambda (x1)
    (begin
      (if (>=fx (cell-ref bufpos_62@genlex)
                (string-length (cell-ref buffer_20@genlex)))
        (let ((x2 (create_string
                    (*fx 2 (cell-ref bufpos_62@genlex)))))
          (begin
            (blit_string
              (cell-ref buffer_20@genlex)
              0
              x2
              0
              (cell-ref bufpos_62@genlex))
            (cell-set! buffer_20@genlex x2)))
        (caml-make-tag 0 1))
      (begin
        (string-set!
          (cell-ref buffer_20@genlex)
          (cell-ref bufpos_62@genlex)
          x1)
        (cell-set!
          bufpos_62@genlex
          (+fx (cell-ref bufpos_62@genlex) 1))))))

(define get_string_221@genlex
  (lambda (x1)
    (let ((x2 (((sub_string_61@fstring
                  (cell-ref buffer_20@genlex))
                0)
               (cell-ref bufpos_62@genlex))))
      (begin
        (cell-set!
          buffer_20@genlex
          initial_buffer_128@genlex)
        x2))))

(define make_lexer_140@genlex
  (lambda (x1)
    (let ((x2 (new_27@hashtbl 17)))
      (begin
        ((do_list_18@list
           (lambda (x3)
             (((add_6@hashtbl x2) x3)
              (caml-make-regular (caml-make-tag 0 6) 1 x3))))
         x1)
        (let ((x3 (lambda (x3)
                    (let* ((handler-top1001 current_handler)
                           (:-d.1002 (unspecified)))
                      (labels
                        ((try1003
                           (:-d.1002)
                           (begin
                             (get-the-continuation :-d.1002)
                             (if (eq? #t #f) (try1003 (try1003 (try1003 1))))
                             (if :-d.1002
                               ((find_75@hashtbl x2) x3)
                               current_handler))))
                        (let ((x4 (try1003 :-d.1002)))
                          (set! current_handler handler-top1001)
                          (if (=fx *try* 1)
                            (begin
                              (set! *try* 0)
                              (labels
                                ((staticfail1004 () (raise x4)))
                                (case (caml-extensible-constr-tag x4)
                                  ((not_found_4@exc)
                                   (caml-make-regular (caml-make-tag 1 6) 1 x3))
                                  (else (staticfail1004)))))
                            x4))))))
              (x4 (lambda (x4)
                    (let ((x5 ((make_string_7@fstring 1) x4)))
                      (let* ((handler-top1006 current_handler)
                             (:-d.1007 (unspecified)))
                        (labels
                          ((try1008
                             (:-d.1007)
                             (begin
                               (get-the-continuation :-d.1007)
                               (if (eq? #t #f) (try1008 (try1008 (try1008 1))))
                               (if :-d.1007
                                 ((find_75@hashtbl x2) x5)
                                 current_handler))))
                          (let ((x6 (try1008 :-d.1007)))
                            (set! current_handler handler-top1006)
                            (if (=fx *try* 1)
                              (begin
                                (set! *try* 0)
                                (labels
                                  ((staticfail1009 () (raise x6)))
                                  (case (caml-extensible-constr-tag x6)
                                    ((not_found_4@exc)
                                     (raise 'parse_error_2@stream))
                                    (else (staticfail1009)))))
                              x6))))))))
          (letrec ((x5 (lambda (x20)
                         (let ((x21 (stream_peek_92@stream x20)))
                           (labels
                             ((staticfail1010
                                ()
                                (begin (stream_junk_216@stream x20) (x4 x21))))
                             (case x21
                               ((#a012 #a026 #\tab #\return #\newline #\space)
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 x20)) (x5 x22))))
                               ((#a255 #a254
                                       #a253
                                       #a252
                                       #a251
                                       #a250
                                       #a249
                                       #a248
                                       #a247
                                       #a246
                                       #a245
                                       #a244
                                       #a243
                                       #a242
                                       #a241
                                       #a240
                                       #a239
                                       #a238
                                       #a237
                                       #a236
                                       #a235
                                       #a234
                                       #a233
                                       #a232
                                       #a231
                                       #a230
                                       #a229
                                       #a228
                                       #a227
                                       #a226
                                       #a225
                                       #a224
                                       #a223
                                       #a222
                                       #a221
                                       #a220
                                       #a219
                                       #a218
                                       #a217
                                       #a216
                                       #a215
                                       #a214
                                       #a213
                                       #a212
                                       #a211
                                       #a210
                                       #a209
                                       #a208
                                       #a207
                                       #a206
                                       #a205
                                       #a204
                                       #a203
                                       #a202
                                       #a201
                                       #a200
                                       #a199
                                       #a198
                                       #a197
                                       #a196
                                       #a195
                                       #a194
                                       #a193
                                       #a192
                                       #\z
                                       #\y
                                       #\x
                                       #\w
                                       #\v
                                       #\u
                                       #\t
                                       #\s
                                       #\r
                                       #\q
                                       #\p
                                       #\o
                                       #\n
                                       #\m
                                       #\l
                                       #\k
                                       #\j
                                       #\i
                                       #\h
                                       #\g
                                       #\f
                                       #\e
                                       #\d
                                       #\c
                                       #\b
                                       #\a
                                       #\Z
                                       #\Y
                                       #\X
                                       #\W
                                       #\V
                                       #\U
                                       #\T
                                       #\S
                                       #\R
                                       #\Q
                                       #\P
                                       #\O
                                       #\N
                                       #\M
                                       #\L
                                       #\K
                                       #\J
                                       #\I
                                       #\H
                                       #\G
                                       #\F
                                       #\E
                                       #\D
                                       #\C
                                       #\B
                                       #\A)
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 x20))
                                    (begin
                                      (reset_buffer_23@genlex
                                        (caml-make-tag 0 1))
                                      (begin
                                        (store_147@genlex x21)
                                        (x6 x22))))))
                               ((#\*
                                 #\|
                                 #\^
                                 #\~
                                 #\\
                                 #\@
                                 #\?
                                 #\>
                                 #\=
                                 #\<
                                 #\:
                                 #\/
                                 #\+
                                 #\#
                                 #\$
                                 #\&
                                 #\%
                                 #\!)
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 x20))
                                    (begin
                                      (reset_buffer_23@genlex
                                        (caml-make-tag 0 1))
                                      (begin
                                        (store_147@genlex x21)
                                        (x7 x22))))))
                               ((#\9 #\8 #\7 #\6 #\5 #\4 #\3 #\2 #\1 #\0)
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 x20))
                                    (begin
                                      (reset_buffer_23@genlex
                                        (caml-make-tag 0 1))
                                      (begin
                                        (store_147@genlex x21)
                                        (x9 x22))))))
                               ((#\`)
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 ((parser_require_204@stream x14)
                                              x20)))
                                    (let ((x23 (stream_require_148@stream x20)))
                                      (labels
                                        ((staticfail1011
                                           ()
                                           (raise 'parse_error_2@stream)))
                                        (let ((:-d.1012 x23))
                                          (cond ((char=? :-d.1012 #\`)
                                                 (begin
                                                   (stream_junk_216@stream x20)
                                                   (caml-make-regular
                                                     (caml-make-tag 5 6)
                                                     1
                                                     x22)))
                                                (else (staticfail1011)))))))))
                               ((#\")
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 x20))
                                    (begin
                                      (reset_buffer_23@genlex
                                        (caml-make-tag 0 1))
                                      (caml-make-regular
                                        (caml-make-tag 4 6)
                                        1
                                        (x13 x22))))))
                               ((#\-)
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 x20)) (x8 x22))))
                               ((#\()
                                (begin
                                  (stream_junk_216@stream x20)
                                  (let ((x22 x20)) (x16 x22))))
                               (else (staticfail1010)))))))
                   (x6 (lambda (x20)
                         (bind-exit
                           (staticexit1014)
                           (labels
                             ((staticfail1013
                                ()
                                (staticexit1014
                                  (x3 (get_string_221@genlex
                                        (caml-make-tag 0 1))))))
                             (let ((x21 (let* ((handler-top1016 current_handler)
                                               (:-d.1017 (unspecified)))
                                          (labels
                                            ((try1018
                                               (:-d.1017)
                                               (begin
                                                 (get-the-continuation :-d.1017)
                                                 (if (eq? #t #f)
                                                   (try1018
                                                     (try1018 (try1018 1))))
                                                 (if :-d.1017
                                                   (stream_peek_92@stream x20)
                                                   current_handler))))
                                            (let ((x21 (try1018 :-d.1017)))
                                              (set! current_handler
                                                handler-top1016)
                                              (if (=fx *try* 1)
                                                (begin
                                                  (set! *try* 0)
                                                  (if (eq? (tag-of x21) 10)
                                                    (staticfail1013)
                                                    (raise x21)))
                                                x21))))))
                               (case x21
                                 ((#\'
                                   #\_
                                   #\9
                                   #\8
                                   #\7
                                   #\6
                                   #\5
                                   #\4
                                   #\3
                                   #\2
                                   #\1
                                   #\0
                                   #a255
                                   #a254
                                   #a253
                                   #a252
                                   #a251
                                   #a250
                                   #a249
                                   #a248
                                   #a247
                                   #a246
                                   #a245
                                   #a244
                                   #a243
                                   #a242
                                   #a241
                                   #a240
                                   #a239
                                   #a238
                                   #a237
                                   #a236
                                   #a235
                                   #a234
                                   #a233
                                   #a232
                                   #a231
                                   #a230
                                   #a229
                                   #a228
                                   #a227
                                   #a226
                                   #a225
                                   #a224
                                   #a223
                                   #a222
                                   #a221
                                   #a220
                                   #a219
                                   #a218
                                   #a217
                                   #a216
                                   #a215
                                   #a214
                                   #a213
                                   #a212
                                   #a211
                                   #a210
                                   #a209
                                   #a208
                                   #a207
                                   #a206
                                   #a205
                                   #a204
                                   #a203
                                   #a202
                                   #a201
                                   #a200
                                   #a199
                                   #a198
                                   #a197
                                   #a196
                                   #a195
                                   #a194
                                   #a193
                                   #a192
                                   #\z
                                   #\y
                                   #\x
                                   #\w
                                   #\v
                                   #\u
                                   #\t
                                   #\s
                                   #\r
                                   #\q
                                   #\p
                                   #\o
                                   #\n
                                   #\m
                                   #\l
                                   #\k
                                   #\j
                                   #\i
                                   #\h
                                   #\g
                                   #\f
                                   #\e
                                   #\d
                                   #\c
                                   #\b
                                   #\a
                                   #\Z
                                   #\Y
                                   #\X
                                   #\W
                                   #\V
                                   #\U
                                   #\T
                                   #\S
                                   #\R
                                   #\Q
                                   #\P
                                   #\O
                                   #\N
                                   #\M
                                   #\L
                                   #\K
                                   #\J
                                   #\I
                                   #\H
                                   #\G
                                   #\F
                                   #\E
                                   #\D
                                   #\C
                                   #\B
                                   #\A)
                                  (begin
                                    (stream_junk_216@stream x20)
                                    (let ((x22 x20))
                                      (begin (store_147@genlex x21) (x6 x22)))))
                                 (else (staticfail1013))))))))
                   (x7 (lambda (x20)
                         (bind-exit
                           (staticexit1020)
                           (labels
                             ((staticfail1019
                                ()
                                (staticexit1020
                                  (x3 (get_string_221@genlex
                                        (caml-make-tag 0 1))))))
                             (let ((x21 (let* ((handler-top1022 current_handler)
                                               (:-d.1023 (unspecified)))
                                          (labels
                                            ((try1024
                                               (:-d.1023)
                                               (begin
                                                 (get-the-continuation :-d.1023)
                                                 (if (eq? #t #f)
                                                   (try1024
                                                     (try1024 (try1024 1))))
                                                 (if :-d.1023
                                                   (stream_peek_92@stream x20)
                                                   current_handler))))
                                            (let ((x21 (try1024 :-d.1023)))
                                              (set! current_handler
                                                handler-top1022)
                                              (if (=fx *try* 1)
                                                (begin
                                                  (set! *try* 0)
                                                  (if (eq? (tag-of x21) 10)
                                                    (staticfail1019)
                                                    (raise x21)))
                                                x21))))))
                               (case x21
                                 ((#\*
                                   #\|
                                   #\^
                                   #\~
                                   #\\
                                   #\@
                                   #\?
                                   #\>
                                   #\=
                                   #\<
                                   #\:
                                   #\/
                                   #\-
                                   #\+
                                   #\#
                                   #\$
                                   #\&
                                   #\%
                                   #\!)
                                  (begin
                                    (stream_junk_216@stream x20)
                                    (let ((x22 x20))
                                      (begin (store_147@genlex x21) (x7 x22)))))
                                 (else (staticfail1019))))))))
                   (x8 (lambda (x20)
                         (bind-exit
                           (staticexit1026)
                           (labels
                             ((staticfail1025 () (staticexit1026 (x4 #\-))))
                             (let ((x21 (let* ((handler-top1028 current_handler)
                                               (:-d.1029 (unspecified)))
                                          (labels
                                            ((try1030
                                               (:-d.1029)
                                               (begin
                                                 (get-the-continuation :-d.1029)
                                                 (if (eq? #t #f)
                                                   (try1030
                                                     (try1030 (try1030 1))))
                                                 (if :-d.1029
                                                   (stream_peek_92@stream x20)
                                                   current_handler))))
                                            (let ((x21 (try1030 :-d.1029)))
                                              (set! current_handler
                                                handler-top1028)
                                              (if (=fx *try* 1)
                                                (begin
                                                  (set! *try* 0)
                                                  (if (eq? (tag-of x21) 10)
                                                    (staticfail1025)
                                                    (raise x21)))
                                                x21))))))
                               (case x21
                                 ((#\9 #\8 #\7 #\6 #\5 #\4 #\3 #\2 #\1 #\0)
                                  (begin
                                    (stream_junk_216@stream x20)
                                    (let ((x22 x20))
                                      (begin
                                        (reset_buffer_23@genlex
                                          (caml-make-tag 0 1))
                                        (begin
                                          (store_147@genlex #\-)
                                          (begin
                                            (store_147@genlex x21)
                                            (x9 x22)))))))
                                 (else (staticfail1025))))))))
                   (x9 (lambda (x20)
                         (bind-exit
                           (staticexit1032)
                           (labels
                             ((staticfail1031
                                ()
                                (staticexit1032
                                  (caml-make-regular
                                    (caml-make-tag 2 6)
                                    1
                                    (int_of_string
                                      (get_string_221@genlex
                                        (caml-make-tag 0 1)))))))
                             (let ((x21 (let* ((handler-top1034 current_handler)
                                               (:-d.1035 (unspecified)))
                                          (labels
                                            ((try1036
                                               (:-d.1035)
                                               (begin
                                                 (get-the-continuation :-d.1035)
                                                 (if (eq? #t #f)
                                                   (try1036
                                                     (try1036 (try1036 1))))
                                                 (if :-d.1035
                                                   (stream_peek_92@stream x20)
                                                   current_handler))))
                                            (let ((x21 (try1036 :-d.1035)))
                                              (set! current_handler
                                                handler-top1034)
                                              (if (=fx *try* 1)
                                                (begin
                                                  (set! *try* 0)
                                                  (if (eq? (tag-of x21) 10)
                                                    (staticfail1031)
                                                    (raise x21)))
                                                x21))))))
                               (case x21
                                 ((#\9 #\8 #\7 #\6 #\5 #\4 #\3 #\2 #\1 #\0)
                                  (begin
                                    (stream_junk_216@stream x20)
                                    (let ((x22 x20))
                                      (begin (store_147@genlex x21) (x9 x22)))))
                                 ((#\.)
                                  (begin
                                    (stream_junk_216@stream x20)
                                    (let ((x22 x20))
                                      (begin
                                        (store_147@genlex #\.)
                                        (x10 x22)))))
                                 ((#\E #\e)
                                  (begin
                                    (stream_junk_216@stream x20)
                                    (let ((x22 x20))
                                      (begin
                                        (store_147@genlex #\E)
                                        (x11 x22)))))
                                 (else (staticfail1031))))))))
                   (x10 (lambda (x20)
                          (bind-exit
                            (staticexit1038)
                            (labels
                              ((staticfail1037
                                 ()
                                 (staticexit1038
                                   (caml-make-regular
                                     (caml-make-tag 3 6)
                                     1
                                     (float_of_string
                                       (get_string_221@genlex
                                         (caml-make-tag 0 1)))))))
                              (let ((x21 (let* ((handler-top1040
                                                  current_handler)
                                                (:-d.1041 (unspecified)))
                                           (labels
                                             ((try1042
                                                (:-d.1041)
                                                (begin
                                                  (get-the-continuation
                                                    :-d.1041)
                                                  (if (eq? #t #f)
                                                    (try1042
                                                      (try1042 (try1042 1))))
                                                  (if :-d.1041
                                                    (stream_peek_92@stream x20)
                                                    current_handler))))
                                             (let ((x21 (try1042 :-d.1041)))
                                               (set! current_handler
                                                 handler-top1040)
                                               (if (=fx *try* 1)
                                                 (begin
                                                   (set! *try* 0)
                                                   (if (eq? (tag-of x21) 10)
                                                     (staticfail1037)
                                                     (raise x21)))
                                                 x21))))))
                                (case x21
                                  ((#\9 #\8 #\7 #\6 #\5 #\4 #\3 #\2 #\1 #\0)
                                   (begin
                                     (stream_junk_216@stream x20)
                                     (let ((x22 x20))
                                       (begin
                                         (store_147@genlex x21)
                                         (x10 x22)))))
                                  ((#\E #\e)
                                   (begin
                                     (stream_junk_216@stream x20)
                                     (let ((x22 x20))
                                       (begin
                                         (store_147@genlex #\E)
                                         (x11 x22)))))
                                  (else (staticfail1037))))))))
                   (x11 (lambda (x20)
                          (bind-exit
                            (staticexit1044)
                            (labels
                              ((staticfail1043
                                 ()
                                 (staticexit1044 (let ((x22 x20)) (x12 x22)))))
                              (let ((x21 (let* ((handler-top1046
                                                  current_handler)
                                                (:-d.1047 (unspecified)))
                                           (labels
                                             ((try1048
                                                (:-d.1047)
                                                (begin
                                                  (get-the-continuation
                                                    :-d.1047)
                                                  (if (eq? #t #f)
                                                    (try1048
                                                      (try1048 (try1048 1))))
                                                  (if :-d.1047
                                                    (stream_peek_92@stream x20)
                                                    current_handler))))
                                             (let ((x21 (try1048 :-d.1047)))
                                               (set! current_handler
                                                 handler-top1046)
                                               (if (=fx *try* 1)
                                                 (begin
                                                   (set! *try* 0)
                                                   (if (eq? (tag-of x21) 10)
                                                     (staticfail1043)
                                                     (raise x21)))
                                                 x21))))))
                                (let ((:-d.1049 x21))
                                  (cond ((or (char=? :-d.1049 #\-)
                                             (char=? :-d.1049 #\+))
                                         (begin
                                           (stream_junk_216@stream x20)
                                           (let ((x22 x20))
                                             (begin
                                               (store_147@genlex x21)
                                               (x12 x22)))))
                                        (else (staticfail1043)))))))))
                   (x12 (lambda (x20)
                          (bind-exit
                            (staticexit1051)
                            (labels
                              ((staticfail1050
                                 ()
                                 (staticexit1051
                                   (caml-make-regular
                                     (caml-make-tag 3 6)
                                     1
                                     (float_of_string
                                       (get_string_221@genlex
                                         (caml-make-tag 0 1)))))))
                              (let ((x21 (let* ((handler-top1053
                                                  current_handler)
                                                (:-d.1054 (unspecified)))
                                           (labels
                                             ((try1055
                                                (:-d.1054)
                                                (begin
                                                  (get-the-continuation
                                                    :-d.1054)
                                                  (if (eq? #t #f)
                                                    (try1055
                                                      (try1055 (try1055 1))))
                                                  (if :-d.1054
                                                    (stream_peek_92@stream x20)
                                                    current_handler))))
                                             (let ((x21 (try1055 :-d.1054)))
                                               (set! current_handler
                                                 handler-top1053)
                                               (if (=fx *try* 1)
                                                 (begin
                                                   (set! *try* 0)
                                                   (if (eq? (tag-of x21) 10)
                                                     (staticfail1050)
                                                     (raise x21)))
                                                 x21))))))
                                (case x21
                                  ((#\9 #\8 #\7 #\6 #\5 #\4 #\3 #\2 #\1 #\0)
                                   (begin
                                     (stream_junk_216@stream x20)
                                     (let ((x22 x20))
                                       (begin
                                         (store_147@genlex x21)
                                         (x12 x22)))))
                                  (else (staticfail1050))))))))
                   (x13 (lambda (x20)
                          (let ((x21 (stream_peek_92@stream x20)))
                            (labels
                              ((staticfail1056
                                 ()
                                 (begin
                                   (stream_junk_216@stream x20)
                                   (let ((x22 x20))
                                     (begin
                                       (store_147@genlex x21)
                                       (x13 x22))))))
                              (let ((:-d.1057 x21))
                                (cond ((char=? :-d.1057 #\")
                                       (begin
                                         (stream_junk_216@stream x20)
                                         (get_string_221@genlex
                                           (caml-make-tag 0 1))))
                                      ((char=? :-d.1057 #\\)
                                       (begin
                                         (stream_junk_216@stream x20)
                                         (let ((x22 ((parser_require_204@stream
                                                       x15)
                                                     x20)))
                                           (let ((x23 x20))
                                             (begin
                                               (store_147@genlex x22)
                                               (x13 x23))))))
                                      (else (staticfail1056))))))))
                   (x14 (lambda (x20)
                          (let ((x21 (stream_peek_92@stream x20)))
                            (labels
                              ((staticfail1058
                                 ()
                                 (begin (stream_junk_216@stream x20) x21)))
                              (let ((:-d.1059 x21))
                                (cond ((char=? :-d.1059 #\\)
                                       (begin
                                         (stream_junk_216@stream x20)
                                         (let ((x22 ((parser_require_204@stream
                                                       x15)
                                                     x20)))
                                           x22)))
                                      (else (staticfail1058))))))))
                   (x15 (lambda (x20)
                          (let ((x21 (stream_peek_92@stream x20)))
                            (labels
                              ((staticfail1060
                                 ()
                                 (begin (stream_junk_216@stream x20) x21)))
                              (case x21
                                ((#\n)
                                 (begin (stream_junk_216@stream x20) #\newline))
                                ((#\r)
                                 (begin (stream_junk_216@stream x20) #\return))
                                ((#\t)
                                 (begin (stream_junk_216@stream x20) #\tab))
                                ((#\9 #\8 #\7 #\6 #\5 #\4 #\3 #\2 #\1 #\0)
                                 (begin
                                   (stream_junk_216@stream x20)
                                   (let ((x22 (stream_require_148@stream x20)))
                                     (labels
                                       ((staticfail1061
                                          ()
                                          (raise 'parse_error_2@stream)))
                                       (case x22
                                         ((#\9
                                           #\8
                                           #\7
                                           #\6
                                           #\5
                                           #\4
                                           #\3
                                           #\2
                                           #\1
                                           #\0)
                                          (begin
                                            (stream_junk_216@stream x20)
                                            (let ((x23 (stream_require_148@stream
                                                         x20)))
                                              (labels
                                                ((staticfail1062
                                                   ()
                                                   (raise 'parse_error_2@stream)))
                                                (case x23
                                                  ((#\9
                                                    #\8
                                                    #\7
                                                    #\6
                                                    #\5
                                                    #\4
                                                    #\3
                                                    #\2
                                                    #\1
                                                    #\0)
                                                   (begin
                                                     (stream_junk_216@stream
                                                       x20)
                                                     (char_of_int
                                                       (+fx (+fx (*fx (-fx (int_of_char
                                                                             x21)
                                                                           48)
                                                                      100)
                                                                 (*fx (-fx (int_of_char
                                                                             x22)
                                                                           48)
                                                                      10))
                                                            (int_of_char
                                                              x23)))))
                                                  (else (staticfail1062)))))))
                                         (else (staticfail1061)))))))
                                (else (staticfail1060)))))))
                   (x16 (lambda (x20)
                          (bind-exit
                            (staticexit1064)
                            (labels
                              ((staticfail1063 () (staticexit1064 (x4 #\())))
                              (let ((x21 (let* ((handler-top1066
                                                  current_handler)
                                                (:-d.1067 (unspecified)))
                                           (labels
                                             ((try1068
                                                (:-d.1067)
                                                (begin
                                                  (get-the-continuation
                                                    :-d.1067)
                                                  (if (eq? #t #f)
                                                    (try1068
                                                      (try1068 (try1068 1))))
                                                  (if :-d.1067
                                                    (stream_peek_92@stream x20)
                                                    current_handler))))
                                             (let ((x21 (try1068 :-d.1067)))
                                               (set! current_handler
                                                 handler-top1066)
                                               (if (=fx *try* 1)
                                                 (begin
                                                   (set! *try* 0)
                                                   (if (eq? (tag-of x21) 10)
                                                     (staticfail1063)
                                                     (raise x21)))
                                                 x21))))))
                                (let ((:-d.1069 x21))
                                  (cond ((char=? :-d.1069 #\*)
                                         (begin
                                           (stream_junk_216@stream x20)
                                           (let ((x22 x20))
                                             (begin (x17 x22) (x5 x22)))))
                                        (else (staticfail1063)))))))))
                   (x17 (lambda (x20)
                          (let ((x21 (stream_peek_92@stream x20)))
                            (labels
                              ((staticfail1070
                                 ()
                                 (begin
                                   (stream_junk_216@stream x20)
                                   (let ((x22 x20)) (x17 x22)))))
                              (let ((:-d.1071 x21))
                                (cond ((char=? :-d.1071 #\()
                                       (begin
                                         (stream_junk_216@stream x20)
                                         (let ((x22 x20)) (x18 x22))))
                                      ((char=? :-d.1071 #\*)
                                       (begin
                                         (stream_junk_216@stream x20)
                                         (let ((x22 x20)) (x19 x22))))
                                      (else (staticfail1070))))))))
                   (x18 (lambda (x20)
                          (let ((x21 (stream_peek_92@stream x20)))
                            (labels
                              ((staticfail1072
                                 ()
                                 (begin
                                   (stream_junk_216@stream x20)
                                   (let ((x22 x20)) (x17 x22)))))
                              (let ((:-d.1073 x21))
                                (cond ((char=? :-d.1073 #\*)
                                       (begin
                                         (stream_junk_216@stream x20)
                                         (let ((x22 x20))
                                           (begin (x17 x22) (x17 x22)))))
                                      (else (staticfail1072))))))))
                   (x19 (lambda (x20)
                          (let ((x21 (stream_peek_92@stream x20)))
                            (labels
                              ((staticfail1074
                                 ()
                                 (begin
                                   (stream_junk_216@stream x20)
                                   (let ((x22 x20)) (x17 x22)))))
                              (let ((:-d.1075 x21))
                                (cond ((char=? :-d.1075 #\))
                                       (begin
                                         (stream_junk_216@stream x20)
                                         (caml-make-tag 0 1)))
                                      (else (staticfail1074)))))))))
            (lambda (x20)
              (stream_from_102@stream (lambda (x21) (x5 x20))))))))))

