;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_hashtbl
  (foreign (include #"caml-bigloo.h"))
  (import)
  (export
    (new_27@hashtbl x1)
    (clear_94@hashtbl x1)
    (resize_83@hashtbl x1)
    (bucket_too_long_84@hashtbl x1)
    (2-6-bucket_too_long_84@hashtbl x1 x2)
    (add_6@hashtbl x1)
    (3-64-add_6@hashtbl x1 x2 x3)
    (remove_141@hashtbl x1)
    (2-74-remove_141@hashtbl x1 x2)
    (find_75@hashtbl x1)
    (2-65-find_75@hashtbl x1 x2)
    (find_all_241@hashtbl x1)
    (2-48-find_all_241@hashtbl x1 x2)
    (do_table_147@hashtbl x1)
    (2-4-do_table_147@hashtbl x1 x2)
    (hash_225@hashtbl x1)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define new_27@hashtbl
  (lambda (x1)
    (caml-make-regular
      (caml-make-tag 0 0)
      2
      2
      (make-vector x1 (caml-make-tag 0 2)))))

(define clear_94@hashtbl
  (lambda (x1)
    (begin
      (caml-constr-set-field! x1 0 2)
      (let ((stop1001
              (-fx (let ((:-d.1002 (caml-constr-get-field x1 1)))
                     (if :-d.1002 (vector-length :-d.1002) 0))
                   1)))
        (let for1000 ((i2 0))
          (if (<=fx i2 stop1001)
            (begin
              (vector-set!
                (caml-constr-get-field x1 1)
                i2
                (caml-make-tag 0 2))
              (for1000 (+fx i2 1)))
            (unspecified)))))))

(define resize_83@hashtbl
  (lambda (x1)
    (let ((x2 (let ((:-d.1003 (caml-constr-get-field x1 1)))
                (if :-d.1003 (vector-length :-d.1003) 0))))
      (let ((x3 (make-vector (+fx x2 x2) (caml-make-tag 0 2))))
        (begin
          (((((blit_vect_203@fvect
                (caml-constr-get-field x1 1))
              0)
             x3)
            0)
           x2)
          (begin
            (((((blit_vect_203@fvect
                  (caml-constr-get-field x1 1))
                0)
               x3)
              x2)
             x2)
            (begin
              (caml-constr-set-field! x1 1 x3)
              (begin
                (caml-constr-set-field!
                  x1
                  0
                  (*fx 2 (caml-constr-get-field x1 0)))
                (caml-make-tag 0 1)))))))))

(begin
  (define bucket_too_long_84@hashtbl
    (lambda (x1)
      (lambda (x2)
        (2-6-bucket_too_long_84@hashtbl x1 x2))))
 (define 2-6-bucket_too_long_84@hashtbl
    (lambda (x1 x2)
      (if (<fx x1 0)
        #t
        (let ((x3 x2))
          (let ((:-d.1004 x3))
            (cond ((eq? :-d.1004 (caml-make-tag 0 2)) #f)
                  (else
                   ((bucket_too_long_84@hashtbl (-fx x1 1))
                    (caml-constr-get-field x3 2)))))))))
)
(begin
  (define add_6@hashtbl
    (lambda (x1)
      (lambda (x2)
        (lambda (x3) (3-64-add_6@hashtbl x1 x2 x3)))))
 (define 3-64-add_6@hashtbl
    (lambda (x1 x2 x3)
      (let ((x4 (modulo
                  (hash_univ_param 10 100 x2)
                  (let ((:-d.1005 (caml-constr-get-field x1 1)))
                    (if :-d.1005 (vector-length :-d.1005) 0)))))
        (let ((x5 (caml-make-regular
                    (caml-make-tag 1 2)
                    3
                    x2
                    x3
                    (vector-ref (caml-constr-get-field x1 1) x4))))
          (begin
            (vector-set! (caml-constr-get-field x1 1) x4 x5)
            (if ((bucket_too_long_84@hashtbl
                   (caml-constr-get-field x1 0))
                 x5)
              (resize_83@hashtbl x1)
              (caml-make-tag 0 1)))))))
)
(begin
  (define remove_141@hashtbl
    (lambda (x1)
      (lambda (x2) (2-74-remove_141@hashtbl x1 x2))))
 (define 2-74-remove_141@hashtbl
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (let ((:-d.1007 x4))
                       (cond ((eq? :-d.1007 (caml-make-tag 0 2))
                              (caml-make-tag 0 2))
                             (else
                              (if (tree_equal (caml-constr-get-field x4 0) x2)
                                (caml-constr-get-field x4 2)
                                (caml-make-regular
                                  (caml-make-tag 1 2)
                                  3
                                  (caml-constr-get-field x4 0)
                                  (caml-constr-get-field x4 1)
                                  (x3 (caml-constr-get-field x4 2))))))))))
        (let ((x4 (modulo
                    (hash_univ_param 10 100 x2)
                    (let ((:-d.1006 (caml-constr-get-field x1 1)))
                      (if :-d.1006 (vector-length :-d.1006) 0)))))
          (begin
            (vector-set!
              (caml-constr-get-field x1 1)
              x4
              (x3 (vector-ref (caml-constr-get-field x1 1) x4)))
            (caml-make-tag 0 1))))))
)
(begin
  (define find_75@hashtbl
    (lambda (x1)
      (lambda (x2) (2-65-find_75@hashtbl x1 x2))))
 (define 2-65-find_75@hashtbl
    (lambda (x1 x2)
      (let ((x3 (vector-ref
                  (caml-constr-get-field x1 1)
                  (modulo
                    (hash_univ_param 10 100 x2)
                    (let ((:-d.1008 (caml-constr-get-field x1 1)))
                      (if :-d.1008 (vector-length :-d.1008) 0))))))
        (let ((:-d.1009 x3))
          (cond ((eq? :-d.1009 (caml-make-tag 0 2))
                 (raise 'not_found_4@exc))
                (else
                 (if (tree_equal x2 (caml-constr-get-field x3 0))
                   (caml-constr-get-field x3 1)
                   (let ((x4 (caml-constr-get-field x3 2)))
                     (let ((:-d.1010 x4))
                       (cond ((eq? :-d.1010 (caml-make-tag 0 2))
                              (raise 'not_found_4@exc))
                             (else
                              (if (tree_equal x2 (caml-constr-get-field x4 0))
                                (caml-constr-get-field x4 1)
                                (let ((x5 (caml-constr-get-field x4 2)))
                                  (let ((:-d.1011 x5))
                                    (cond ((eq? :-d.1011 (caml-make-tag 0 2))
                                           (raise 'not_found_4@exc))
                                          (else
                                           (if (tree_equal
                                                 x2
                                                 (caml-constr-get-field x5 0))
                                             (caml-constr-get-field x5 1)
                                             (letrec ((x6 (lambda (x7)
                                                            (let ((:-d.1012 x7))
                                                              (cond ((eq? :-d.1012
                                                                          (caml-make-tag
                                                                            0
                                                                            2))
                                                                     (raise 'not_found_4@exc))
                                                                    (else
                                                                     (if (tree_equal
                                                                           x2
                                                                           (caml-constr-get-field
                                                                             x7
                                                                             0))
                                                                       (caml-constr-get-field
                                                                         x7
                                                                         1)
                                                                       (x6 (caml-constr-get-field
                                                                             x7
                                                                             2)))))))))
                                               (x6 (caml-constr-get-field
                                                     x5
                                                     2))))))))))))))))))))
)
(begin
  (define find_all_241@hashtbl
    (lambda (x1)
      (lambda (x2) (2-48-find_all_241@hashtbl x1 x2))))
 (define 2-48-find_all_241@hashtbl
    (lambda (x1 x2)
      (letrec ((x3 (lambda (x4)
                     (let ((:-d.1014 x4))
                       (cond ((eq? :-d.1014 (caml-make-tag 0 2)) '())
                             (else
                              (if (tree_equal (caml-constr-get-field x4 0) x2)
                                (cons (caml-constr-get-field x4 1)
                                      (x3 (caml-constr-get-field x4 2)))
                                (x3 (caml-constr-get-field x4 2)))))))))
        (x3 (vector-ref
              (caml-constr-get-field x1 1)
              (modulo
                (hash_univ_param 10 100 x2)
                (let ((:-d.1013 (caml-constr-get-field x1 1)))
                  (if :-d.1013 (vector-length :-d.1013) 0))))))))
)
(begin
  (define do_table_147@hashtbl
    (lambda (x1)
      (lambda (x2) (2-4-do_table_147@hashtbl x1 x2))))
 (define 2-4-do_table_147@hashtbl
    (lambda (x1 x2)
      (let ((x3 (let ((:-d.1015 (caml-constr-get-field x2 1)))
                  (if :-d.1015 (vector-length :-d.1015) 0))))
        (let ((stop1017
                (-fx (let ((:-d.1019 (caml-constr-get-field x2 1)))
                       (if :-d.1019 (vector-length :-d.1019) 0))
                     1)))
          (let for1016 ((i4 0))
            (if (<=fx i4 stop1017)
              (begin
                (letrec ((x6 (lambda (x7)
                               (let ((:-d.1018 x7))
                                 (cond ((eq? :-d.1018 (caml-make-tag 0 2))
                                        (caml-make-tag 0 1))
                                       (else
                                        (if (eq? (modulo
                                                   (hash_univ_param
                                                     10
                                                     100
                                                     (caml-constr-get-field
                                                       x7
                                                       0))
                                                   x3)
                                                 i4)
                                          (begin
                                            ((x1 (caml-constr-get-field x7 0))
                                             (caml-constr-get-field x7 1))
                                            (x6 (caml-constr-get-field x7 2)))
                                          (x6 (caml-constr-get-field
                                                x7
                                                2)))))))))
                  (x6 (vector-ref (caml-constr-get-field x2 1) i4)))
                (for1016 (+fx i4 1)))
              (unspecified)))))))
)
(define hash_225@hashtbl
  (lambda (x1) (hash_univ_param 50 500 x1)))

